// Code generated by go_code.py; DO NOT EDIT.

package hints
import "kitty/tools/cli"
func create_cmd(root *cli.Command, run_func func(*cli.Command, *Options, []string)(int, error)) {
ans := root.AddSubCommand(&cli.Command{
Name: "hints",
ShortDescription: "Select text from screen with keyboard",
HelpText: "Select text from the screen using the keyboard. Defaults to searching for URLs.",
Run: func(cmd *cli.Command, args []string) (int, error) {
opts := Options{}
err := cmd.GetOptionValues(&opts)
if err != nil { return 1, err }
return run_func(cmd, &opts, args)},
})
ans.Add(cli.OptionSpec{
            Name: "--program",
            Type: "list",
            Dest: "Program",
            Help: "What program to use to open matched text. Defaults to the default open program for the operating system. Various special values are supported:\n\n:code:`-`\n    paste the match into the terminal window.\n\n:code:`@`\n    copy the match to the clipboard\n\n:code:`*`\n    copy the match to the primary selection (on systems that support primary selections)\n\n:code:`@NAME`\n    copy the match to the specified buffer, e.g. :code:`@a`\n\n:code:`default`\n    run the default open program. Note that when using the hyperlink :code:`--type` the default is to use the kitty :doc:`hyperlink handling </open_actions>` facilities.\n\n:code:`launch`\n    run :doc:`/launch` to open the program in a new kitty tab, window, overlay, etc. For example::\n\n        --program \"launch --type=tab vim\"\n\nCan be specified multiple times to run multiple programs.",
        })
ans.Add(cli.OptionSpec{
            Name: "--type",
            Type: "choices",
            Dest: "Type",
            Help: "The type of text to search for. A value of :code:`linenum` is special, it looks for error messages using the pattern specified with :option:`--regex`, which must have the named groups: :code:`path` and :code:`line`. If not specified, will look for :code:`path:line`. The :option:`--linenum-action` option controls where to display the selected error message, other options are ignored.",
        
Choices: "url, hash, hyperlink, ip, line, linenum, path, regex, word",

Completer: cli.NamesCompleter("Choices for type", "url", "hash", "hyperlink", "ip", "line", "linenum", "path", "regex", "word"),
Default: "url",
})
ans.Add(cli.OptionSpec{
            Name: "--regex",
            Type: "",
            Dest: "Regex",
            Help: "The regular expression to use when option :option:`--type` is set to :code:`regex`, in Perl 5 syntax. If you specify a numbered group in the regular expression, only the group will be matched. This allow you to match text ignoring a prefix/suffix, as needed. The default expression matches lines. To match text over multiple lines, things get a little tricky, as line endings are a sequence of zero or more null bytes followed by either a carriage return or a newline character. To have a pattern match over line endings you will need to match the character set ``[\\0\\r\\n]``. The newlines and null bytes are automatically stripped from the returned text. If you specify named groups and a :option:`--program`, then the program will be passed arguments corresponding to each named group of the form :code:`key=value`.",
        
Default: "(?m)^\\s*(.+)\\s*$",
})
ans.Add(cli.OptionSpec{
            Name: "--linenum-action",
            Type: "choices",
            Dest: "LinenumAction",
            Help: "Where to perform the action on matched errors. :code:`self` means the current window, :code:`window` a new kitty window, :code:`tab` a new tab, :code:`os_window` a new OS window and :code:`background` run in the background. The actual action is whatever arguments are provided to the kitten, for example: :code:`kitten hints --type=linenum --linenum-action=tab vim +{line} {path}` will open the matched path at the matched line number in vim in a new kitty tab. Note that in order to use :option:`--program` to copy or paste the provided arguments, you need to use the special value :code:`self`.",
        
Choices: "self, background, os_window, tab, window",

Completer: cli.NamesCompleter("Choices for linenum-action", "self", "background", "os_window", "tab", "window"),
Default: "self",
})
ans.Add(cli.OptionSpec{
            Name: "--url-prefixes",
            Type: "",
            Dest: "UrlPrefixes",
            Help: "Comma separated list of recognized URL prefixes. Defaults to the list of prefixes defined by the :opt:`url_prefixes` option in :file:`kitty.conf`.",
        
Default: "default",
})
ans.Add(cli.OptionSpec{
            Name: "--url-excluded-characters",
            Type: "",
            Dest: "UrlExcludedCharacters",
            Help: "Characters to exclude when matching URLs. Defaults to the list of characters defined by the :opt:`url_excluded_characters` option in :file:`kitty.conf`. The syntax for this option is the same as for :opt:`url_excluded_characters`.",
        
Default: "default",
})
ans.Add(cli.OptionSpec{
            Name: "--word-characters",
            Type: "",
            Dest: "WordCharacters",
            Help: "Characters to consider as part of a word. In addition, all characters marked as alphanumeric in the Unicode database will be considered as word characters. Defaults to the :opt:`select_by_word_characters` option from :file:`kitty.conf`.",
        })
ans.Add(cli.OptionSpec{
            Name: "--minimum-match-length",
            Type: "int",
            Dest: "MinimumMatchLength",
            Help: "The minimum number of characters to consider a match.",
        
Default: "3",
})
ans.Add(cli.OptionSpec{
            Name: "--multiple",
            Type: "bool-set",
            Dest: "Multiple",
            Help: "Select multiple matches and perform the action on all of them together at the end. In this mode, press :kbd:`Esc` to finish selecting.",
        })
ans.Add(cli.OptionSpec{
            Name: "--multiple-joiner",
            Type: "",
            Dest: "MultipleJoiner",
            Help: "String for joining multiple selections when copying to the clipboard or inserting into the terminal. The special values are: :code:`space` - a space character, :code:`newline` - a newline, :code:`empty` - an empty joiner, :code:`json` - a JSON serialized list, :code:`auto` - an automatic choice, based on the type of text being selected. In addition, integers are interpreted as zero-based indices into the list of selections. You can use :code:`0` for the first selection and :code:`-1` for the last.",
        
Default: "auto",
})
ans.Add(cli.OptionSpec{
            Name: "--add-trailing-space",
            Type: "choices",
            Dest: "AddTrailingSpace",
            Help: "Add trailing space after matched text. Defaults to :code:`auto`, which adds the space when used together with :option:`--multiple`.",
        
Choices: "auto, always, never",

Completer: cli.NamesCompleter("Choices for add-trailing-space", "auto", "always", "never"),
Default: "auto",
})
ans.Add(cli.OptionSpec{
            Name: "--hints-offset",
            Type: "int",
            Dest: "HintsOffset",
            Help: "The offset (from zero) at which to start hint numbering. Note that only numbers greater than or equal to zero are respected.",
        
Default: "1",
})
ans.Add(cli.OptionSpec{
            Name: "--alphabet",
            Type: "",
            Dest: "Alphabet",
            Help: "The list of characters to use for hints. The default is to use numbers and lowercase English alphabets. Specify your preference as a string of characters. Note that you need to specify the :option:`--hints-offset` as zero to use the first character to highlight the first match, otherwise it will start with the second character by default.",
        })
ans.Add(cli.OptionSpec{
            Name: "--ascending",
            Type: "bool-set",
            Dest: "Ascending",
            Help: "Make the hints increase from top to bottom, instead of decreasing from top to bottom.",
        })
ans.Add(cli.OptionSpec{
            Name: "--hints-foreground-color",
            Type: "str",
            Dest: "HintsForegroundColor",
            Help: "The foreground color for hints. You can use color names or hex values. For the eight basic named terminal colors you can also use the :code:`bright-` prefix to get the bright variant of the color.",
        
Default: "black",
})
ans.Add(cli.OptionSpec{
            Name: "--hints-background-color",
            Type: "str",
            Dest: "HintsBackgroundColor",
            Help: "The background color for hints. You can use color names or hex values. For the eight basic named terminal colors you can also use the :code:`bright-` prefix to get the bright variant of the color.",
        
Default: "green",
})
ans.Add(cli.OptionSpec{
            Name: "--hints-text-color",
            Type: "str",
            Dest: "HintsTextColor",
            Help: "The foreground color for text pointed to by the hints. You can use color names or hex values. For the eight basic named terminal colors you can also use the :code:`bright-` prefix to get the bright variant of the color.",
        
Default: "bright-gray",
})
ans.Add(cli.OptionSpec{
            Name: "--customize-processing",
            Type: "",
            Dest: "CustomizeProcessing",
            Help: "Name of a python file in the kitty config directory which will be imported to provide custom implementations for pattern finding and performing actions on selected matches. You can also specify absolute paths to load the script from elsewhere. See https://sw.kovidgoyal.net/kitty/kittens/hints/ for details.",
        })
ans.Add(cli.OptionSpec{
            Name: "--window-title",
            Type: "",
            Dest: "WindowTitle",
            Help: "The title for the hints window, default title is based on the type of text being hinted.",
        })
}
type Options struct {
Program []string
Type string
Regex string
LinenumAction string
UrlPrefixes string
UrlExcludedCharacters string
WordCharacters string
MinimumMatchLength int
Multiple bool
MultipleJoiner string
AddTrailingSpace string
HintsOffset int
Alphabet string
Ascending bool
HintsForegroundColor string
HintsBackgroundColor string
HintsTextColor string
CustomizeProcessing string
WindowTitle string
}
