// Code generated by go_code.py; DO NOT EDIT.

package icat
import "kitty/tools/cli"
func create_cmd(root *cli.Command, run_func func(*cli.Command, *Options, []string)(int, error)) {
ans := root.AddSubCommand(&cli.Command{
Name: "icat",
ShortDescription: "Display images in the terminal",
Usage: "[options] image-file-or-url-or-directory ...",
HelpText: "A cat like utility to display images in the terminal. You can specify multiple image files and/or directories. Directories are scanned recursively for image files. If STDIN is not a terminal, image data will be read from it as well. You can also specify HTTP(S) or FTP URLs which will be automatically downloaded and displayed.",
Run: func(cmd *cli.Command, args []string) (int, error) {
opts := Options{}
err := cmd.GetOptionValues(&opts)
if err != nil { return 1, err }
return run_func(cmd, &opts, args)},
})
ans.Add(cli.OptionSpec{
            Name: "--align",
            Type: "choices",
            Dest: "Align",
            Help: "Horizontal alignment for the displayed image.",
        
Choices: "center, left, right",

Completer: cli.NamesCompleter("Choices for align", "center", "left", "right"),
Default: "center",
})
ans.Add(cli.OptionSpec{
            Name: "--place",
            Type: "",
            Dest: "Place",
            Help: "Choose where on the screen to display the image. The image will be scaled to fit into the specified rectangle. The syntax for specifying rectangles is <:italic:`width`>x<:italic:`height`>@<:italic:`left`>x<:italic:`top`>. All measurements are in cells (i.e. cursor positions) with the origin :italic:`(0, 0)` at the top-left corner of the screen. Note that the :option:`--align` option will horizontally align the image within this rectangle. By default, the image is horizontally centered within the rectangle. Using place will cause the cursor to be positioned at the top left corner of the image, instead of on the line after the image.",
        })
ans.Add(cli.OptionSpec{
            Name: "--scale-up",
            Type: "bool-set",
            Dest: "ScaleUp",
            Help: "When used in combination with :option:`--place` it will cause images that are smaller than the specified area to be scaled up to use as much of the specified area as possible.",
        })
ans.Add(cli.OptionSpec{
            Name: "--background",
            Type: "",
            Dest: "Background",
            Help: "Specify a background color, this will cause transparent images to be composited on top of the specified color.",
        
Default: "none",
})
ans.Add(cli.OptionSpec{
            Name: "--mirror",
            Type: "choices",
            Dest: "Mirror",
            Help: "Mirror the image about a horizontal or vertical axis or both.",
        
Choices: "none, both, horizontal, vertical",

Completer: cli.NamesCompleter("Choices for mirror", "none", "both", "horizontal", "vertical"),
Default: "none",
})
ans.Add(cli.OptionSpec{
            Name: "--clear",
            Type: "bool-set",
            Dest: "Clear",
            Help: "Remove all images currently displayed on the screen.",
        })
ans.Add(cli.OptionSpec{
            Name: "--transfer-mode",
            Type: "choices",
            Dest: "TransferMode",
            Help: "Which mechanism to use to transfer images to the terminal. The default is to auto-detect. :italic:`file` means to use a temporary file, :italic:`memory` means to use shared memory, :italic:`stream` means to send the data via terminal escape codes. Note that if you use the :italic:`file` or :italic:`memory` transfer modes and you are connecting over a remote session then image display will not work.",
        
Choices: "detect, file, memory, stream",

Completer: cli.NamesCompleter("Choices for transfer-mode", "detect", "file", "memory", "stream"),
Default: "detect",
})
ans.Add(cli.OptionSpec{
            Name: "--detect-support",
            Type: "bool-set",
            Dest: "DetectSupport",
            Help: "Detect support for image display in the terminal. If not supported, will exit with exit code 1, otherwise will exit with code 0 and print the supported transfer mode to stderr, which can be used with the :option:`--transfer-mode` option.",
        })
ans.Add(cli.OptionSpec{
            Name: "--detection-timeout",
            Type: "float",
            Dest: "DetectionTimeout",
            Help: "The amount of time (in seconds) to wait for a response from the terminal, when detecting image display support.",
        
Default: "10",
})
ans.Add(cli.OptionSpec{
            Name: "--use-window-size",
            Type: "",
            Dest: "UseWindowSize",
            Help: "Instead of querying the terminal for the window size, use the specified size, which must be of the format: width_in_cells,height_in_cells,width_in_pixels,height_in_pixels",
        })
ans.Add(cli.OptionSpec{
            Name: "--print-window-size",
            Type: "bool-set",
            Dest: "PrintWindowSize",
            Help: "Print out the window size as <:italic:`width`>x<:italic:`height`> (in pixels) and quit. This is a convenience method to query the window size if using :code:`kitten icat` from a scripting language that cannot make termios calls.",
        })
ans.Add(cli.OptionSpec{
            Name: "--stdin",
            Type: "choices",
            Dest: "Stdin",
            Help: "Read image data from STDIN. The default is to do it automatically, when STDIN is not a terminal, but you can turn it off or on explicitly, if needed.",
        
Choices: "detect, no, yes",

Completer: cli.NamesCompleter("Choices for stdin", "detect", "no", "yes"),
Default: "detect",
})
ans.Add(cli.OptionSpec{
            Name: "--silent",
            Type: "bool-set",
            Dest: "Silent",
            Help: "Not used, present for legacy compatibility.",
        })
ans.Add(cli.OptionSpec{
            Name: "--engine",
            Type: "choices",
            Dest: "Engine",
            Help: "The engine used for decoding and processing of images. The default is to use the most appropriate engine.  The :code:`builtin` engine uses Go's native imaging libraries. The :code:`magick` engine uses ImageMagick which requires it to be installed on the system.",
        
Choices: "auto, builtin, magick",

Completer: cli.NamesCompleter("Choices for engine", "auto", "builtin", "magick"),
Default: "auto",
})
ans.Add(cli.OptionSpec{
            Name: "--z-index -z",
            Type: "",
            Dest: "ZIndex",
            Help: "Z-index of the image. When negative, text will be displayed on top of the image. Use a double minus for values under the threshold for drawing images under cell background colors. For example, :code:`--1` evaluates as -1,073,741,825.",
        
Default: "0",
})
ans.Add(cli.OptionSpec{
            Name: "--loop -l",
            Type: "int",
            Dest: "Loop",
            Help: "Number of times to loop animations. Negative values loop forever. Zero means only the first frame of the animation is displayed. Otherwise, the animation is looped the specified number of times.",
        
Default: "-1",
})
ans.Add(cli.OptionSpec{
            Name: "--hold",
            Type: "bool-set",
            Dest: "Hold",
            Help: "Wait for a key press before exiting after displaying the images.",
        })
ans.Add(cli.OptionSpec{
            Name: "--unicode-placeholder",
            Type: "bool-set",
            Dest: "UnicodePlaceholder",
            Help: "Use the Unicode placeholder method to display the images. Useful to display images from within full screen terminal programs that do not understand the kitty graphics protocol such as multiplexers or editors. See :ref:`graphics_unicode_placeholders` for details. Note that when using this method, placed (with :option:`--place`) images that do not fit on the screen, will get wrapped at the screen edge instead of getting truncated. This wrapping is per line and therefore the image will look like it is interleaved with blank lines.",
        })
ans.Add(cli.OptionSpec{
            Name: "--passthrough",
            Type: "choices",
            Dest: "Passthrough",
            Help: "Whether to surround graphics commands with escape sequences that allow them to passthrough programs like tmux. The default is to detect when running inside tmux and automatically use the tmux passthrough escape codes. Note that when this option is enabled it implies :option:`--unicode-placeholder` as well.",
        
Choices: "detect, none, tmux",

Completer: cli.NamesCompleter("Choices for passthrough", "detect", "none", "tmux"),
Default: "detect",
})
ans.Add(cli.OptionSpec{
            Name: "--image-id",
            Type: "int",
            Dest: "ImageId",
            Help: "The graphics protocol id to use for the created image. Normally, a random id is created if needed. This option allows control of the id. When multiple images are sent, sequential ids starting from the specified id are used. Valid ids are from 1 to 4294967295. Numbers outside this range are automatically wrapped.",
        
Default: "0",
})
ans.ArgCompleter = cli.MimepatCompleter("Images", cli.CWD, "image/*")
}
type Options struct {
Align string
Place string
ScaleUp bool
Background string
Mirror string
Clear bool
TransferMode string
DetectSupport bool
DetectionTimeout float64
UseWindowSize string
PrintWindowSize bool
Stdin string
Silent bool
Engine string
ZIndex string
Loop int
Hold bool
UnicodePlaceholder bool
Passthrough string
ImageId int
}
