// Code generated by go_code.py; DO NOT EDIT.




// License: GPLv3 Copyright: 2022, Kovid Goyal, <kovid at kovidgoyal.net>

// Code generated by gen-go-code.py; DO NOT EDIT.

package at

import (
	"fmt"
	"strings"
	"time"

	"kitty/tools/cli"
	"kitty/tools/utils"
)

var _ = fmt.Print
var _ = strings.Join

type options_send_text_type struct {
	Match string
MatchTab string
All bool
ExcludeActive bool
Stdin bool
FromFile string
BracketedPaste string
}

var options_send_text options_send_text_type

type send_text_json_type struct {
	Data escaped_string`json:"data,omitempty"`
Match escaped_string`json:"match,omitempty"`
Match_tab escaped_string`json:"match_tab,omitempty"`
All bool`json:"all,omitempty"`
Exclude_active bool`json:"exclude_active,omitempty"`
Session_id escaped_string`json:"session_id,omitempty"`
Bracketed_paste string`json:"bracketed_paste,omitempty"`
}

func create_payload_send_text(io_data *rc_io_data, cmd *cli.Command, args []string) (err error) {
	payload := send_text_json_type{}
	err = parse_send_text(io_data, args)
if err != nil { return err }
payload.Match = escaped_string(options_send_text.Match)
payload.Match_tab = escaped_string(options_send_text.MatchTab)
payload.All = options_send_text.All
payload.Exclude_active = options_send_text.ExcludeActive
payload.Bracketed_paste = options_send_text.BracketedPaste
	io_data.rc.Payload = payload
	return
}

func create_rc_send_text(args []string) (*utils.RemoteControlCmd, error) {
	rc := utils.RemoteControlCmd{
		Cmd:        "send-text",
		Version:    ProtocolVersion,
		NoResponse: true,
		Stream:     false,
	}
	if rc.Stream {
		stream_id, err := utils.HumanRandomId(128)
		if err != nil {
			return nil, err
		}
		rc.StreamId = stream_id
	}
	if false {
		async_id, err := utils.HumanRandomId(128)
		if err != nil {
			return nil, err
		}
		rc.Async = async_id
	}
	return &rc, nil
}

func run_send_text(cmd *cli.Command, args []string) (return_code int, err error) {
	err = cmd.GetOptionValues(&options_send_text)
	if err != nil {
		return
	}

	rc, err := create_rc_send_text(args)
	if err != nil {
		return
	}
	nrv, err := cli.GetOptionValue[bool](cmd, "NoResponse")
	if err == nil {
		rc.NoResponse = nrv
	}
	var timeout float64 = 10.0
	rt, err := cli.GetOptionValue[float64](cmd, "ResponseTimeout")
	if err == nil {
		timeout = rt
	}
	io_data := rc_io_data{
		cmd:                    cmd,
		rc:                     rc,
		timeout:                time.Duration(timeout * float64(time.Second)),
		string_response_is_err: false,
	}
	err = create_payload_send_text(&io_data, cmd, args)
	if err != nil {
		return
	}

	err = send_rc_command(&io_data)
	if ee, ok := err.(*exit_error); ok && !running_shell {
		return ee.exit_code, nil
	}
	return
}

func setup_send_text(parent *cli.Command) *cli.Command {
	ans := parent.AddSubCommand(&cli.Command{
		Name:             "send-text",
		Usage:            " [TEXT TO SEND]",
		ShortDescription: "Send arbitrary text to specified windows",
		HelpText:         "Send arbitrary text to specified windows. The text follows Python escaping rules. So you can use :link:`escapes <https://www.gnu.org/software/bash/manual/html_node/ANSI_002dC-Quoting.html>` like :code:`'\\\\e'` to send control codes and :code:`'\\\\u21fa'` to send Unicode characters. Remember to use single-quotes otherwise the backslash is interpreted as a shell escape character. If you use the :option:`kitten @ send-text --match` option the text will be sent to all matched windows. By default, text is sent to only the currently active window. Note that errors are not reported, for technical reasons, so send-text always succeeds, even if no text was sent to any window.",
		Run:              run_send_text,
	})
	ans.Add(cli.OptionSpec{
            Name: "--match -m",
            Type: "",
            Dest: "Match",
            Help: "The window to match. Match specifications are of the form: :italic:`field:query`. Where :italic:`field` can be one of: :code:`id`, :code:`title`, :code:`pid`, :code:`cwd`, :code:`cmdline`, :code:`num`, :code:`env`, :code:`var`, :code:`state`, :code:`neighbor`, and :code:`recent`. :italic:`query` is the expression to match. Expressions can be either a number or a regular expression, and can be :ref:`combined using Boolean operators <search_syntax>`.\n\nThe special value :code:`all` matches all windows.\n\nFor numeric fields: :code:`id`, :code:`pid`, :code:`num` and :code:`recent`, the expression is interpreted as a number, not a regular expression. Negative values for :code:`id` match from the highest id number down, in particular, -1 is the most recently created window.\n\nThe field :code:`num` refers to the window position in the current tab, starting from zero and counting clockwise (this is the same as the order in which the windows are reported by the :ref:`kitten @ ls <at-ls>` command).\n\nThe window id of the current window is available as the :envvar:`KITTY_WINDOW_ID` environment variable.\n\nThe field :code:`recent` refers to recently active windows in the currently active tab, with zero being the currently active window, one being the previously active window and so on.\n\nThe field :code:`neighbor` refers to a neighbor of the active window in the specified direction, which can be: :code:`left`, :code:`right`, :code:`top` or :code:`bottom`.\n\nWhen using the :code:`env` field to match on environment variables, you can specify only the environment variable name or a name and value, for example, :code:`env:MY_ENV_VAR=2`.\n\nSimilarly, the :code:`var` field matches on user variables set on the window. You can specify name or name and value as with the :code:`env` field.\n\nThe field :code:`state` matches on the state of the window. Supported states are: :code:`active`, :code:`focused`, :code:`needs_attention`, :code:`parent_active`, :code:`parent_focused`, :code:`self`, :code:`overlay_parent`.  Active windows are the windows that are active in their parent tab. There is only one focused window and it is the window to which keyboard events are delivered. If no window is focused, the last focused window is matched. The value :code:`self` matches the window in which the remote control command is run. The value :code:`overlay_parent` matches the window that is under the :code:`self` window, when the self window is an overlay.\n\nNote that you can use the :ref:`kitten @ ls <at-ls>` command to get a list of windows.",
        })
ans.Add(cli.OptionSpec{
            Name: "--match-tab -t",
            Type: "",
            Dest: "MatchTab",
            Help: "The tab to match. Match specifications are of the form: :italic:`field:query`. Where :italic:`field` can be one of: :code:`id`, :code:`index`, :code:`title`, :code:`window_id`, :code:`window_title`, :code:`pid`, :code:`cwd`, :code:`cmdline` :code:`env`, :code:`var`, :code:`state` and :code:`recent`. :italic:`query` is the expression to match. Expressions can be either a number or a regular expression, and can be :ref:`combined using Boolean operators <search_syntax>`.\n\nThe special value :code:`all` matches all tabs.\n\nFor numeric fields: :code:`id`, :code:`index`, :code:`window_id`, :code:`pid` and :code:`recent`, the expression is interpreted as a number, not a regular expression. Negative values for :code:`id`/:code:`window_id` match from the highest id number down, in particular, -1 is the most recently created tab/window.\n\nWhen using :code:`title` or :code:`id`, first a matching tab is looked for, and if not found a matching window is looked for, and the tab for that window is used.\n\nYou can also use :code:`window_id` and :code:`window_title` to match the tab that contains the window with the specified id or title.\n\nThe :code:`index` number is used to match the nth tab in the currently active OS window. The :code:`recent` number matches recently active tabs in the currently active OS window, with zero being the currently active tab, one the previously active tab and so on.\n\nWhen using the :code:`env` field to match on environment variables, you can specify only the environment variable name or a name and value, for example, :code:`env:MY_ENV_VAR=2`. Tabs containing any window with the specified environment variables are matched. Similarly, :code:`var` matches tabs containing any window with the specified user variable.\n\nThe field :code:`state` matches on the state of the tab. Supported states are: :code:`active`, :code:`focused`, :code:`needs_attention`, :code:`parent_active` and :code:`parent_focused`. Active tabs are the tabs that are active in their parent OS window. There is only one focused tab and it is the tab to which keyboard events are delivered. If no tab is focused, the last focused tab is matched.\n\nNote that you can use the :ref:`kitten @ ls <at-ls>` command to get a list of tabs.",
        })
ans.Add(cli.OptionSpec{
            Name: "--all",
            Type: "bool-set",
            Dest: "All",
            Help: "Match all windows.",
        })
ans.Add(cli.OptionSpec{
            Name: "--exclude-active",
            Type: "bool-set",
            Dest: "ExcludeActive",
            Help: "Do not send text to the active window, even if it is one of the matched windows.",
        })
ans.Add(cli.OptionSpec{
            Name: "--stdin",
            Type: "bool-set",
            Dest: "Stdin",
            Help: "Read the text to be sent from :italic:`stdin`. Note that in this case the text is sent as is, not interpreted for escapes. If stdin is a terminal, you can press :kbd:`Ctrl+D` to end reading.",
        })
ans.Add(cli.OptionSpec{
            Name: "--from-file",
            Type: "",
            Dest: "FromFile",
            Help: "Path to a file whose contents you wish to send. Note that in this case the file contents are sent as is, not interpreted for escapes.",
        })
ans.Add(cli.OptionSpec{
            Name: "--bracketed-paste",
            Type: "choices",
            Dest: "BracketedPaste",
            Help: "When sending text to a window, wrap the text in bracketed paste escape codes. The default is to not do this. A value of :code:`auto` means, bracketed paste will be used only if the program running in the window has turned on bracketed paste mode.",
        
Choices: "disable, auto, enable",

Completer: cli.NamesCompleter("Choices for bracketed-paste", "disable", "auto", "enable"),
Default: "disable",
})
	return ans
}

func init() {
	register_at_cmd(setup_send_text)
}
